var EngageApp = {};

var changedId = "";

function mkdir()
{
	try
	{
		console.log("Going to verify uploads folder exists");

		var options = {};
		options.path = "file://internal/Uploads";



		var successCb = function (cbObject) {
			console.log("A directory is created successfully.");
		};

		var failureCb = function (cbObject) {
			var errorCode = cbObject.errorCode;
			var errorText = cbObject.errorText;

			console.log(" Error Code [" + errorCode + "]: " + errorText);
		};

		var storage = new Storage();
		storage.mkdir(successCb, failureCb, options);

	}
	catch (eee)
	{
		console.log("error calling mkdir: " + eee.message);
	}
}


EngageApp.onLoad = function()
{
		console.log("Starting up EngagePHD ipk");
	    try
	    {

	        var configuration = new Configuration();

	        var options = {};
	        options.enabled = true;

	        configuration.debug( function successCb()
	        {
	            console.log("Succeeded to enable the debug mode");
	        }, function(){}, options);



	    }
	    catch (e)
	    {
		//EngageApp.TempAppend("<br>error setting debug: " + e.message);
		}

		console.log("going to check for uploads folder in 750ms");

try
{
	setTimeout(function()
	{

		mkdir();

	}, 750);

}
catch (edd){}

	try
	{
		setTimeout(function()
		{
			//EngageApp.TempAppend("<br>Requesting service");



			webOS.service.request('luna://com.lg.app.signage.service/', {
				method: 'serverOn',
				onSuccess: function ()
				{
					//EngageApp.TempAppend("<br>" + new Date() + ' SERVER ON');
				},
				onFailure: function (err) {
					EngageApp.TempAppend("<br>" + JSON.stringify(err));
				},
				subscribe: true
			});
		}, 2000);
	}
	catch (e)
	{
		EngageApp.TempAppend("<br>error with service: " + e.message);
	}

	 if (EngageApp.GetId() == "")
		EngageApp.PromptId("");


	EngageApp.DeleteZips();

	//1: 49
	//2: 50
	//3: 51
	//4: 52
	//5: 53
	//6: 54
	//7: 55
	//8: 56
	//9: 57
	//0: 48
	//- (play): 415
	//Info (stop) : 413
	//Return : 13
	document.onkeydown = function(event)
	{
		var keyCode = event.keyCode;
		if (keyCode == 13)
		{
			if (captureId)
			{
				DOWNLOAD_IN_PROGRESS = false;
				EngageApp.SaveId(true);
			}

		}
		else if (keyCode == 413)
		{
			if (captureId)
			{
				EngageApp.SaveId(false);
				return;
			}

			infoKeyCount++;

			//MainTizen.log("info: " + infoKeyCount);

			setTimeout(function()
			{
				infoKeyCount = 0;
			}, 60000);

			if (infoKeyCount > 3)
			{
				infoKeyCount = 0;

				EngageApp.PromptId("");

			}
		}
		else if (keyCode == 49)
		{
			EngageApp.ProcessKey("1");
		}
		else if (keyCode == 50)
		{
			EngageApp.ProcessKey("2");
		}
		else if (keyCode == 51)
		{
			EngageApp.ProcessKey("3");
		}
		else if (keyCode == 52)
		{
			EngageApp.ProcessKey("4");
		}
		else if (keyCode == 53)
		{
			EngageApp.ProcessKey("5");
		}
		else if (keyCode == 54)
		{
			EngageApp.ProcessKey("6");
		}
		else if (keyCode == 55)
		{
			EngageApp.ProcessKey("7");
		}
		else if (keyCode == 56)
		{
			EngageApp.ProcessKey("8");
		}
		else if (keyCode == 57)
		{
			EngageApp.ProcessKey("9");
		}
		else if (keyCode == 48)
		{
			EngageApp.ProcessKey("0");
		}
		else if (keyCode == 415 || keyCode == 1006)
		{
			EngageApp.ProcessKey("-");
		}
	};

	LGSync.init();


};

EngageApp.ProcessKey = function(k)
{
	if (captureId)
	{
		if (firstKey)
		{
			firstKey= false;
			$("#tmpKey").html("");
		}

		$("#tmpKey").append(k);
		return;
	}

};

EngageApp.onUnload = function()
{
};

EngageApp.getPath = function()
{
	return "file://internal/";
};

EngageApp.TempAppend = function(msg)
{
	console.log(new Date() + " " + msg);
	$("#dload").show().append(msg);
};

EngageApp.Status = function(msg)
{
	$("#dload").show().html(msg);
};

var captureId = false;
var firstKey = false;
var DOWNLOAD_IN_PROGRESS = false;

EngageApp.GetId = function()
{

	if (changedId != "")
		return changedId;

		var disp = "";
		try
		{
			if (id)
				disp = id;
		}
		catch (e)
		{

		}

		if (disp == "")
			disp = localStorage.getItem("EngagePHD");


		if (disp == undefined || disp == null)
		return "";

		return disp;

};

EngageApp.PromptId = function(m)
{

	var disp = EngageApp.GetId();

	captureId = true;
	firstKey = true;
	$("#engageKey").show();
	if (m != "")
	{
		$("#tmpKey").html(m);
	}
	else
		$("#tmpKey").html(disp);

	var table = "<table align='center'>";
	table += "</table>";

	$("#dbg").html(table);
};


var zipName = "";
var engageHost = "";
var infoKeyCount = 0;

var arrz = [];

EngageApp.Cleanup = function()
{

	for (var y = 0; y < currentAssets.length; y++)
	{
		var item = currentAssets[y].toLowerCase();

		if (item.indexOf(".mp4") > -1 || item.indexOf(".jpg") > -1 || item.indexOf(".png") > -1)
		{
			var found = false;
			for (var x = 0; x < arrz.length; x++)
			{
				if (arrz[x] == item)
					found = true;
			}

			if (!found)
			{
				console.log("Need to clean up file: " + currentAssets[y]);

				var options = {
					file: 'file://internal/Uploads/' + currentAssets[y],
				};

				var storage = new Storage();
				storage.removeFile(function()
				{
					console.log("Asset removed");
				},
				function(cbo)
				{
					var errorCode = cbo.errorCode;
					var errorText = cbo.errorText;
					console.log("remove Error Code [" + errorCode + "]: " + errorText);

				}, options);
			}
		}
	}

};

EngageApp.List = function(path, debug)
{
    var successCb = function (cbObject) {
        var files = cbObject.files;
        for (var i = 0; i < files.length; ++i) {
            var fileInfo = files[i];
            EngageApp.TempAppend(" File Name: " + fileInfo.name);
            console.log("File Type: " + fileInfo.type);
            console.log("File Size: " + fileInfo.size);
        }
    };

    var failureCb = function (cbObject) {
        var errorCode = cbObject.errorCode;
        var errorText = cbObject.errorText;
        EngageApp.TempAppend("<br>Error Code [" + errorCode + "]: " + errorText);
    };

    // List files in the internal memory
    var listOption = {
        path: "file://internal"
    };

    var storage = new Storage();
    storage.listFiles(successCb, failureCb, listOption);
};

EngageApp.DeleteZips = function()
{
	try
	{
		  var successCb = function () {
				console.log("Removing File done.");
			};

			var failureCb = function (cbObject) {
				var errorCode = cbObject.errorCode;
				var errorText = cbObject.errorText;
				console.log("Error Code [" + errorCode + "]: " + errorText);
			};


			// Delete a file
			var options = {
				file: 'file://internal/Assets.zip',
			};

			var storage = new Storage();
			storage.removeFile(successCb, failureCb, options);

	}
	catch (e)
	{
		//TempAppend("e: " + e.message);
	}
};

EngageApp.DeleteAssets = function()
{
	try
	{
		    var successCbz = function (cbObject) {
				console.log("Removed all files ");

				EngageApp.List();
			};

			var failureCbz = function (cbObject) {
				var errorCode = cbObject.errorCode;
				var errorText = cbObject.errorText;
				console.log(" Error Code [" + errorCode + "]: " + errorText);
			};

			var options = {
				device: 'internal' // This will remove all the files in the local storage.
			};

			var storage = new Storage();
			storage.removeAll(successCbz, failureCbz, options);
	}
	catch (e)
	{
		EngageApp.TempAppend("e: " + e.message);
	}
};

EngageApp.getRandomInt = function (min, max)
{
  return Math.floor(Math.random() * (max - min)) + min;
};

EngageApp.Delete = function(path)
{
	//var result = document.getElementById("unzipPlugin").Delete(path);
};

var engageBuild = "";
var restartOnFinish = false;

EngageApp.DownloadEngage = function()
{
	//engageBuild = Math.floor((Math.random() * 1000000) + 1);
	engageBuild = EngageApp.GetId();

	if (EngageApp.GetId() == "15-2-27" || EngageApp.GetId() == "15-2-5")
	{
		engageHost = "10.0.0.30";
		EngageApp.DownloadApp();
		return;
	}


	$.get("http://go.pinghd.com/Tv/SimpleValidatePlayer/" + EngageApp.GetId(), function(data)
	{
		//MainTizen.log("GO found id: [" + data + "]");

		if (data == "true")
		{
			engageHost = "go.pinghd.com";
			EngageApp.DownloadApp();
		}
		else
		{
			$.get("http://dev.pinghd.com/Tv/SimpleValidatePlayer/" + EngageApp.GetId(), function(d)
			{
				//MainTizen.log("Dev found id: [" + d + "]");

				if (d == "true")
				{
					engageHost = "dev.pinghd.com";
					EngageApp.DownloadApp();
				}
				else
				{
					DOWNLOAD_IN_PROGRESS = false;
					EngageApp.PromptId("Invalid Id");
					return;
				}
			});
		}
	});
};

EngageApp.SaveId = function(forceDownload)
{

	if ($("#tmpKey").html() == "777")
	{
		EngageApp.DeleteAssets();

		EngageApp.PromptId("Assets cleared");
		return;
	}

	EngageApp.DeleteZips();

	var download = false;

	try
	{
	 if (localStorage.getItem("EngagePHD") == undefined
			 || localStorage.getItem("EngagePHD") == null
			 || localStorage.getItem("EngagePHD") == ""
			 || localStorage.getItem("EngagePHD") != $("#tmpKey").html())
	 {
		 download = true;
	 }


	localStorage.setItem("EngagePHD", $("#tmpKey").html());
   }
   catch (e)
   {
	   EngageApp.TempAppend("<br> Error saving: " + e.message);
   }

   changedId = $("#tmpKey").html();


	$("#tmpKey").empty();
	$("#engageKey").hide();
	infoKeyCount = 0;
	captureId = false;

	if (download || forceDownload)
	{
		restartOnFinish = true;
		EngageApp.DownloadEngage();
	}


};

EngageApp.DownloadApp = function()
{
	if (DOWNLOAD_IN_PROGRESS)
		return;

	DOWNLOAD_IN_PROGRESS = true;

	zipName = "Assets.zip";

	var tmp = "";

	//EngageApp.Status(localStorage.getItem("EngagePHD") + " " + engageHost);

	try
	{


		var storage = new Storage();

		//EngageApp.TempAppend("<br>Create storage.");

		var successCb = function ()
		{
			EngageApp.TempAppend("<br>Copying File done.");

			DOWNLOAD_IN_PROGRESS = false;
			EngageApp.Status("Complete");

			var timeout = 2000;
			setTimeout(function()
			{
				$("#dload").html("");

				DOWNLOAD_IN_PROGRESS = false;

					try
					{
						var configuration = new Configuration();
						var successCbx = function()
						{
							//EngageApp.TempAppend("<br>Cache is cleared");
						}
						var failureCbx = function(cbObject) {}
						configuration.clearCache(successCbx, failureCbx);
					}
					catch (e)
					{
					}

				var successCbZip = function () {
					EngageApp.TempAppend("<br>Unzip complete");

					//EngageApp.List();


					setTimeout(function()
					{
						////////////////////////////////////////////////////
						// Want to just restart app here but when I do, it brings up old JS files showing incorrect content
						// but if I reboot, correct content shows. I've tried scap 1.3 as well.
						////////////////////////////////////////////////////

						//var configuration = new Configuration();
						//configuration.restartApplication(function(cb){}, function(cb){});

						//var powerOptions = {};
						//powerOptions.powerCommand = Power.PowerCommand.REBOOT;
						//new Power().executePowerCommand(function(){}, function(){}, powerOptions);

try
{

						listAssets();
}
catch (e) {}

					}, 2000);

				};

				var failureCbZip = function (cbObject) {
					var errorCode = cbObject.errorCode;
					var errorText = cbObject.errorText;
					console.log(" Error Code [" + errorCode + "]: " + errorText);

					EngageApp.Status("Unzip failed");

						var powerOptions = {};
						powerOptions.powerCommand = Power.PowerCommand.REBOOT;
						new Power().executePowerCommand(function(){}, function(){}, powerOptions);
				};

				var optionsZip = {
					zipPath: 'file://internal/Assets.zip',
					targetPath: 'file://internal',
				};

				//var storage = new Storage();
				storage.unzipFile(successCbZip, failureCbZip, optionsZip);


			}, timeout);


		};

		var failureCb = function (cbObject) {
			EngageApp.TempAppend("<br>Error");
			var errorCode = cbObject.errorCode;
			var errorText = cbObject.errorText;
			EngageApp.TempAppend("<br>Error Code [" + errorCode + "]: " + errorText);
		};

		var options_remote_to_local = {
			source: "http://" + engageHost + "/s/" + EngageApp.GetId() + "/Samsung.zip?dl=true&lg=true&scapVer=1.3&ipk=true&processAssets=false",
			destination: 'file://internal/Assets.zip'
		};

		EngageApp.Status("...");
		storage.copyFile(successCb, failureCb, options_remote_to_local);

	}
	catch (eeee)
	{
		EngageApp.TempAppend("<br>Error: " + eeee.message);
	}

};


function listAssets()
{
    var successCb = function (cbObject)
    {
        var files = cbObject.files;
        for (var i = 0; i < files.length; ++i)
        {
            var fileInfo = files[i];
            console.log("File Name: " + fileInfo.name + ", File Size: " + fileInfo.size);

            currentAssets.push(fileInfo.name);
        }

        EngageApp.processFiles();
    };

    var failureCb = function (cbObject) {
        var errorCode = cbObject.errorCode;
        var errorText = cbObject.errorText;
        console.log(" Error Code [" + errorCode + "]: " + errorText);
    };

    // List files in the internal memory
    var listOption = {
        path: "file://internal/Uploads"
    };

    var storage = new Storage();
    storage.listFiles(successCb, failureCb, listOption);


}
var rackspace = "";
var currentAssets = [];
var queue = [];
EngageApp.processFiles = function()
{

	EngageApp.Status("Assets");
	arrz = [];

	try
	{

		//$.get( "http://" + engageHost + "/Tv/PrepareAndroid/" + EngageApp.GetId() + "?downloadId=" + engageBuild + "&dl=true&processAssets=false", function( data )
		$.get( "http://" + engageHost + "/Tv/BrightSign/" + EngageApp.GetId() + "?lg=true&rackUrl=true", function( data )
		{

			try
			{
				var split = data.replace( /\n/g, "|" ).replace( /\r/g, "|" ).split("|");
				queue = [];

				for (var x = 0; x < split.length; x++)
				{

					if (split[x] == "" || split[x] == "widget.info" || split[x] == "config.xml")
						continue;

					//EngageApp.TempAppend("<br>" + split[x]);


					var fi = split[x];

		    		if (fi.indexOf("Rackspace_") == 0)
    				{
		    			continue;
	    			}

		    		if (fi.indexOf("Secure_") == 0)
    				{
		    			rackspace = fi.substring(7);

		    			continue;
	    			}

					if (fi.indexOf("WidgetAsset") == 0)
					{
						fi = fi.replace("_", "/");

						console.log("Processing file: " + fi);

						queue.push(fi);

					}
					else if (fi.indexOf("Asset") == 0)
					{
						fi = "Uploads/" + split[x];

						arrz.push(split[x].toLowerCase());

						var found = false;


						for (var y = 0; y < currentAssets.length; y++)
						{
							//if (fi.indexOf(currentAssets[y]) > -1 || currentAssets[y].indexOf(split[x]) > -1)
							if (split[x] == currentAssets[y])
								found = true;
						}

						if (found)
						{
							//EngageApp.TempAppend("<br>exists: " + split[x]);
							continue;
						}

						//EngageApp.TempAppend("<br>Queue: " + split[x]);

						console.log("Processing file: " + split[x]);

						queue.push(fi);
					}
				}

				EngageApp.Cleanup();
				EngageApp.processQueue();

			}
			catch (e3)
			{
				EngageApp.TempAppend("<br>err3: "+ e3.message);
			}

		}).fail(function()
		{
			//MainTizen.log("Prepare failed", true);
			DOWNLOAD_IN_PROGRESS = false;
		});

	}
	catch (e2)
	{
		EngageApp.TempAppend("<br>err2: "+ e2.message);
	}

};

var currentPath = "";
var processingZip = false;
var currentUrl = "";

EngageApp.startQueue = function(urlPath, path)
{
	processingZip = false;
	currentUrl = urlPath;
	currentPath = path;
	var dest = EngageApp.getPath() + path;
	//var r = loader.StartDownFile(urlPath, dest, 0, 10);

		var failureCb = function (cbObject) {
			EngageApp.TempAppend("<br>Error");
			var errorCode = cbObject.errorCode;
			var errorText = cbObject.errorText;
			EngageApp.TempAppend("<br>Error Code [" + errorCode + "]: " + errorText);
			EngageApp.processQueue();
		};

		var options_remote_to_local = {
			source: currentUrl,
			destination: dest
		};

		var storage = new Storage();

		//EngageApp.TempAppend("<br>Create storage.");

		var successCb = function ()
		{
			EngageApp.processQueue();

		};


		storage.copyFile(successCb, failureCb, options_remote_to_local);
};

EngageApp.processQueue = function()
{

	try
	{
		EngageApp.Status(queue.length);

		var q = queue.pop();

		if (q != undefined)
		{
			var lastSlash = q.lastIndexOf("/");

			var folder = "";
			var file = "";
			var temp = q;

			if (lastSlash > -1) {
				folder = "" + q.substring(0, lastSlash);
				file = q.substring(lastSlash + 1, q.length);

			}
			else
				file = q;

			var last = file.lastIndexOf(".");
			var save = file.substring(0, last);
			var ext = file.substring(last);

			//EngageApp.TempAppend("<br>Processing: " + q);

			if (q.indexOf("WidgetAsset") > -1)
			{
				console.log("downloading: http://" + engageHost + "/" + q.replace("WidgetAsset", "Uploads/WidgetAsset"));
				EngageApp.startQueue("http://" + engageHost + "/" + q.replace("WidgetAsset", "Uploads/WidgetAsset"), q);

			}
			else if (q.indexOf("Asset") > -1)
			{

				if (rackspace != "")
				{

					console.log(rackspace + "/" + q.substring(8));

					EngageApp.startQueue(rackspace + "/" + q.substring(8), q);
				}
				else
					EngageApp.startQueue("http://" + engageHost + "/" + q, q);
			}
			else
				EngageApp.startQueue("http://" + engageHost + "/brightsign/" + engageBuild + "/" + q, q);

		}
		else
		{

			EngageApp.Status("Complete");

			DOWNLOAD_IN_PROGRESS = false;


			if (restartOnFinish)
			{
				var powerOptions = {};
				powerOptions.powerCommand = Power.PowerCommand.REBOOT;
				new Power().executePowerCommand(function(){}, function(){}, powerOptions);

			}
			else
			{
				location.reload(true);
			}

		}

	}
	catch (e2)
	{
		EngageApp.TempAppend("<br>err queue: "+ e2.message);
	}

};
